#include <stdio.h>
#include "io.h"
#include "mc_string.h"

char tag_names[60][4] = {
		"TXT\0",	"B\0",		"EM\0",		"I\0",		"PL\0",
		"S\0",		"TT\0",		"U\0",		"BAD\0",	"BAD\0",
		"BAD\0",	"/B\0",		"/EM\0",	"/I\0",		"/PL\0",
		"/S\0",		"/TT\0",	"/U\0",		"BAD\0",	"BAD\0",
		"r\0",		"g\0",		"b\0",		"c\0",		"m\0",
		"y\0",		"k\0",		"w\0",		"BAD\0",	"BAD\0",
		"/r\0",		"/g\0",		"/b\0",		"/c\0",		"/m\0",
		"/y\0",		"/k\0",		"/w\0",		"BAD\0",	"BAD\0",
		"0\0",		"1\0",		"2\0",		"3\0",		"4\0",
		"5\0",		"6\0",		"7\0",		"8\0",		"9\0",
		"/0\0",		"/1\0",		"/2\0",		"/3\0",		"/4\0",
		"/5\0",		"/6\0",		"/7\0",		"/8\0",		"/9\0"
};

int is_text(struct doc_node* a)
{
	return (a->type == 0);
}
int is_opentag(struct doc_node* a)
{
	return ( (a->type/10) %2 ==0 );
}
int is_closetag(struct doc_node* a)
{
	return ( (a->type/10) %2 ==1 );
}

struct doc_node* delete_tag(struct doc_node* a)
{
	struct doc_node* tmp = a->next;

	a->prev->next = a->next;
	a->next->prev = a->prev;
	free(a);
	return tmp;
}

struct doc_node* scan_input()
{
	int c;
	struct doc_node* root = malloc(sizeof(struct doc_node));
	struct doc_node* cur = root;
	struct doc_node* old = NULL;
	
	while (c != EOF)
	{
		// initialize values in the new node
		cur->text = NULL;
		cur->type = 9; // invalid tag code

		c = getchar();
		if ( c == '<' )
		{
			// TAG
			c = getchar();
			if ( c == 'B' )			{ cur->type = 1; }
			else if ( c == 'E' )	{ cur->type = 2; }
			else if ( c == 'I' )	{ cur->type = 3; }
			else if ( c == 'P' )	{ cur->type = 4; }
			else if ( c == 'S' )	{ cur->type = 5; }
			else if ( c == 'T' )	{ cur->type = 6; }
			else if ( c == 'U' )	{ cur->type = 7; }
			else if ( c == 'r' )	{ cur->type = 20; }
			else if ( c == 'g' )	{ cur->type = 21; }
			else if ( c == 'b' )	{ cur->type = 22; }
			else if ( c == 'c' )	{ cur->type = 23; }
			else if ( c == 'm' )	{ cur->type = 24; }
			else if ( c == 'y' )	{ cur->type = 25; }
			else if ( c == 'k' )	{ cur->type = 26; }
			else if ( c == 'w' )	{ cur->type = 27; }
			else if ( (c >='0') && (c<='9') ) 
				{ cur->type = (c-'0')+40; }
			else if ( c == '/' )
			{
				c = getchar();
				if ( c == 'B' )			{ cur->type = 11; }
				else if ( c == 'E' )	{ cur->type = 12; }
				else if ( c == 'I' )	{ cur->type = 13; }
				else if ( c == 'P' )	{ cur->type = 14; }
				else if ( c == 'S' )	{ cur->type = 15; }
				else if ( c == 'T' )	{ cur->type = 16; }
				else if ( c == 'U' )	{ cur->type = 17; }
				else if ( c == 'r' )	{ cur->type = 30; }
				else if ( c == 'g' )	{ cur->type = 31; }
				else if ( c == 'b' )	{ cur->type = 32; }
				else if ( c == 'c' )	{ cur->type = 33; }
				else if ( c == 'm' )	{ cur->type = 34; }
				else if ( c == 'y' )	{ cur->type = 35; }
				else if ( c == 'k' )	{ cur->type = 36; }
				else if ( c == 'w' )	{ cur->type = 37; }
				else if ( (c>='0') && (c<='9') ) 
					{ cur->type = (c-'0')+50; }
			}
			while ( (c!=EOF) && (c!='>') )
			{
				c = getchar();
			}
		}
		else if ( c != EOF )
		{
			// text
			cur->type = 0;
			cur->text = strnew();
			while ( ( c != '<' ) && (c != EOF ) )
			{
				strtailaddc(cur->text, c);
				c = getchar();
			}
			ungetc(c,stdin);
		}

		if ( c == EOF )
		{
			// delete extraneous node
			if ( cur->type == 9 )
			{
				free(cur);
				old->next = NULL;
			}
			else
				cur->next = NULL;
		}
		else
		{
			// setup next node
			cur->prev = old;
			cur->next = malloc(sizeof(struct doc_node));
			old = cur;
			cur = cur->next;
		}
	}
	return root;
}
void print_output(struct doc_node* ptr)
{
	while ( ptr != NULL )
	{
		switch(ptr->type)
		{
			case 0:		strprint(ptr->text);
						break;
			default: 	printf("<%s>",tag_names[ptr->type]);
						break;
		}
		ptr = ptr->next;
	}
}

