#include "mc_string.h"
#include <stdlib.h>
#include <stdio.h>

/*
struct mc_string
{
	char* contents;
	long space;
	long length;
}
*/

struct mc_string* strnew()
{
	struct mc_string* newstr = malloc(sizeof(struct mc_string));
	if ( newstr == NULL )
		return NULL;

	newstr->contents = malloc(1001*sizeof(char));
	if ( newstr->contents == NULL )
		return NULL;

	newstr->contents[0] = '\0';
	newstr->length = 0;
	newstr->space = 1000;

	return newstr;
}

int strckspc(struct mc_string* a, int len)
{
	if ( a->length + len > a->space )
	{
		char* temp = a->contents;
		a->contents = realloc(temp, a->space+1001);
		if ( a->contents < 0 )
		{
			a->contents = temp;
			return -1;
		}
		else
			a->space += 1000;
	}
	return 0;
}

int strtailaddc(struct mc_string* a, char c)
{
	// allocate space as necessary
	strckspc(a,1);

	// copy the character over.
	a->contents[a->length] = c;
	a->length++;
	a->contents[a->length] = '\0';
	return 0;
}

char strtaildelc(struct mc_string* a)
{
	char c;

	if ( a->length == 0 )
		return '\0';

	a->length--;
	c = a->contents[ a->length ];
	a->contents[ a->length ] = '\0';
	return c;
}

int strheadaddc(struct mc_string* a, char c)
{
	long i;

	if ( strckspc(a,1) < 0 )
		return -1;

	for(i=a->length; i>=0; i--)
		a->contents[i+1]=a->contents[i];

	a->contents[0]=c;
	a->length++;
	return 0;
}

int strheadadd(struct mc_string* a, char* s)
{
	long i;
	long len = strlen(s);

	if ( strckspc(a,len) < 0 )
		return -1;

//	printf("length: %ld\n",a->length);
//	printf("space: %ld\n",a->space);
//	printf("len: %ld\n",len);
//	printf("contents: %s\n",a->contents);
//	printf("prepend: %s\n",s);
		
	for(i=a->length; i>=0; i--)
		a->contents[i+len]=a->contents[i];

	for(i=0; i<len; i++)
		a->contents[i]=s[i];

//	printf("new: %s\n",a->contents);

	a->length += len;
	return 0;
}

char* strheaddel(struct mc_string* a, int n)
{
	char* s;
	long i;

	if (n > a->length)
		n = a->length;

	s = malloc(n*sizeof(char));
	if ( s == NULL)
		return NULL;

	for ( i=0; i < a->length+1; i++ )
	{
		s[i] = a->contents[i];
		if ( i+n < a->length+1 )
			a->contents[i] = a->contents[i+n];
	}
	a->length -= n;
	return s;
}

void strprint(struct mc_string* a)
{
	long i;
	for(i=0;i<a->length;i++)
		if ( a->contents[i] != '>' )
			putchar( a->contents[i] );
}
