#include <stdlib.h>
#include "state.h"

/*
struct statestack
{
	struct statestack* up;
	struct statestack* down;
	long level;
	char flags;
	char u_level;
	short size;
	char color;
	char tag_deleted;
};
*/

#define  B_ATTR 0x0001
#define EM_ATTR 0x0002
#define  I_ATTR 0x0004
#define  S_ATTR 0x0008
#define TT_ATTR 0x0010

struct statestack* newstack()
{
	struct statestack* ret = malloc(sizeof(struct statestack));
	ret->down = NULL;
	ret->up = NULL;

	ret->level = 0;
	ret->flags = 0;
	ret->u_level = 0;
	ret->size = -1;
	ret->color = 'q';
	ret->tag_deleted = 0;

	return ret;
}
struct statestack* newstate(struct statestack* a)
{
	struct statestack* ret = malloc(sizeof(struct statestack));
	ret->down = NULL;
	ret->up = a;
	a->down = ret;

	ret->level = a->level+1;
	ret->flags = a->flags;
	ret->u_level = a->u_level;
	ret->size = a->size;
	ret->color = a->color;
	ret->tag_deleted = 0;

	return ret;
}

struct statestack* restorestate(struct statestack* a)
{
	struct statestack* tmp = a;
	a = a->up;
	free(tmp);
	return a;
}

short equivstates(struct statestack* a, struct statestack* b)
{
	if ( a->flags   != b->flags )
		return 0;

	if ( a->u_level != b->u_level )
		return 0;

	if ( a->size    != b->size )
		return 0;

	if ( a->color   != b->color )
		return 0;

	return 1;
}

void set_b(struct statestack* a)
{
	a->flags |= B_ATTR;
}
void clear_b(struct statestack* a)
{
	a->flags &= ~B_ATTR;
}
short test_b(struct statestack* a)
{
	return ( a->flags & B_ATTR );
}

void toggle_em(struct statestack* a)
{
	if ( test_s(a) )
		return;
	if ( test_em(a) )
		a->flags &= ~EM_ATTR;
	else
		a->flags |= EM_ATTR;
}
void clear_em(struct statestack* a)
{
	a->flags &= ~EM_ATTR;
}
short test_em(struct statestack* a)
{
	return ( a->flags & EM_ATTR );
}

void set_i(struct statestack* a)
{
	a->flags |= I_ATTR;
}
void clear_i(struct statestack* a)
{
	a->flags &= ~I_ATTR;
}
short test_i(struct statestack* a)
{
	return ( a->flags & I_ATTR );
}

void set_s(struct statestack* a)
{
	a->flags |= S_ATTR;
}
void clear_s(struct statestack* a)
{
	a->flags &= ~S_ATTR;
}
short test_s(struct statestack* a)
{
	return ( a->flags & S_ATTR );
}

void set_tt(struct statestack* a)
{
	a->flags |= TT_ATTR;
}
void clear_tt(struct statestack* a)
{
	a->flags &= ~TT_ATTR;
}
short test_tt(struct statestack* a)
{
	return ( a->flags & TT_ATTR );
}

void inc_u(struct statestack* a)
{
	if ( a->u_level < 3 )
		a->u_level++;
}
void clear_u(struct statestack* a)
{
	a->u_level = 0;
}
short test_u(struct statestack* a)
{
	return a->u_level;
}

void set_size(struct statestack* a,short newsize)
{
	a->size = newsize;
}
short get_size(struct statestack* a)
{
	return a->size;
}

void set_color(struct statestack* a,char newcolor)
{
	a->color = newcolor;
}
short get_color(struct statestack* a)
{
	return a->color;
}
